From 36b1dbac2f746ab3a8a5344a836639dabd2eb818 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Oct 28 2020 20:33:33 +0000
Subject: [PATCH 1069/2232] Merge pull request #373 from dtolnay/include


Distinguish quoted vs bracketed includes in gen::include
---

diff --git a/gen/src/include.rs b/gen/src/include.rs
index 3255902..959b029 100644
--- a/gen/src/include.rs
+++ b/gen/src/include.rs
@@ -1,4 +1,5 @@
 use crate::gen::out::OutFile;
+use crate::syntax::IncludeKind;
 use std::fmt::{self, Display};
 
 /// The complete contents of the "rust/cxx.h" header.
@@ -48,9 +49,15 @@ fn find_line(mut offset: usize, line: &str) -> Option<usize> {
     }
 }
 
+#[derive(PartialEq)]
+pub struct Include {
+    pub path: String,
+    pub kind: IncludeKind,
+}
+
 #[derive(Default, PartialEq)]
 pub struct Includes {
-    custom: Vec<String>,
+    custom: Vec<Include>,
     pub array: bool,
     pub cstddef: bool,
     pub cstdint: bool,
@@ -70,24 +77,30 @@ impl Includes {
         Includes::default()
     }
 
-    pub fn insert(&mut self, include: impl AsRef<str>) {
-        self.custom.push(include.as_ref().to_owned());
+    pub fn insert(&mut self, include: Include) {
+        self.custom.push(include);
     }
 }
 
-impl Extend<String> for Includes {
-    fn extend<I: IntoIterator<Item = String>>(&mut self, iter: I) {
-        self.custom.extend(iter);
+impl<'a> Extend<&'a String> for Includes {
+    fn extend<I: IntoIterator<Item = &'a String>>(&mut self, iter: I) {
+        self.custom.extend(iter.into_iter().map(|path| Include {
+            path: path.clone(),
+            kind: IncludeKind::Quoted,
+        }));
     }
 }
 
 impl Display for Includes {
     fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
         for include in &self.custom {
-            if include.starts_with('<') && include.ends_with('>') {
-                writeln!(f, "#include {}", include)?;
-            } else {
-                writeln!(f, "#include \"{}\"", include.escape_default())?;
+            match include.kind {
+                IncludeKind::Quoted => {
+                    writeln!(f, "#include \"{}\"", include.path.escape_default())?;
+                }
+                IncludeKind::Bracketed => {
+                    writeln!(f, "#include <{}>", include.path)?;
+                }
             }
         }
         if self.array {
diff --git a/gen/src/write.rs b/gen/src/write.rs
index a354ae4..f1c7a11 100644
--- a/gen/src/write.rs
+++ b/gen/src/write.rs
@@ -1,11 +1,10 @@
+use crate::gen::include::Include;
 use crate::gen::out::OutFile;
 use crate::gen::{include, Opt};
 use crate::syntax::atom::Atom::{self, *};
 use crate::syntax::namespace::Namespace;
 use crate::syntax::symbol::Symbol;
-use crate::syntax::{
-    mangle, Api, Enum, ExternFn, ExternType, IncludeKind, Signature, Struct, Type, Types, Var,
-};
+use crate::syntax::{mangle, Api, Enum, ExternFn, ExternType, Signature, Struct, Type, Types, Var};
 use proc_macro2::Ident;
 use std::collections::HashMap;
 
@@ -23,13 +22,12 @@ pub(super) fn gen(
         writeln!(out.front, "#pragma once");
     }
 
-    out.include.extend(opt.include.clone());
+    out.include.extend(&opt.include);
     for api in apis {
         if let Api::Include(include) = api {
-            match include.kind {
-                IncludeKind::Quoted => out.include.insert(&include.path),
-                IncludeKind::Bracketed => out.include.insert(format!("<{}>", include.path)),
-            }
+            let path = include.path.clone();
+            let kind = include.kind;
+            out.include.insert(Include { path, kind });
         }
     }
 

